PSF-LoginServer - master < Back


# Packages

-  package root
  Definition Classes
    root
-  package net
  Definition Classes
    root
-  package psforever
  Definition Classes
    net
-  package objects
  Definition Classes
    psforever
-  package serverobject
  Definition Classes
    objects
-  package structures
  Definition Classes
    serverobject
- Amenity
- AmenityDefinition
- AmenityOwner
- AutoRepairStats
- Building
- BuildingDefinition
- FoundationBuilder
- PoweredAmenityControl
- SphereOfInfluence
- StructureType
- WarpGate
- WarpGateDefinition

c

net.psforever.objects.serverobject.structures

# Amenity

###

#### abstract class Amenity extends PlanetSideServerObject with Vitality with StandardResistanceProfile

Amenities are elements of the game that belong to other elements of the game.
Normal `PlanetSideServerObject` entities (server objects) tend to have properties that are completely internalized. An `Amenity` is a server object that maintains a fixed association with another server object. This association strips away at the internalization and redirects a reference to some properties somewhere else. An `Amenity` object belongs to its `Owner` object; the `Amenity` objects look to its `Owner` object for some of its properties.

Source
  Amenity.scala
See also

  `AmenityOwner`

  `FactionAffinity`

Linear Supertypes
StandardResistanceProfile, ResistanceProfile, Vitality, VitalsHistory, PlanetSideServerObject, ZoneAware, FactionAffinity, PlanetSideGameObject, WorldEntity, IdentifiableEntity, Identifiable, AnyRef, Any
Known Subclasses
Door, Generator, IFFLock, Locker, VehicleSpawnPad, Painbox, ResourceSilo, OrbitalShuttlePad, ShuttleAmenity, ProximityTerminal, Terminal, CaptureTerminal, ImplantTerminalMech, SpawnTube, FacilityTurret, InternalTelepad, ProximityTerminalUtility, SpawnTubeUtility, TeleportPadTerminalUtility, TerminalUtility

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Amenity
2. StandardResistanceProfile
3. ResistanceProfile
4. Vitality
5. VitalsHistory
6. PlanetSideServerObject
7. ZoneAware
8. FactionAffinity
9. PlanetSideGameObject
10. WorldEntity
11. IdentifiableEntity
12. Identifiable
13. AnyRef
14. Any

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Instance Constructors

1.  new Amenity()

### Abstract Value Members

1.  abstract def Definition: AmenityDefinition
   Definition Classes
     Amenity → Vitality → PlanetSideGameObject

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  def Actor: ActorRef

   Retrieve a reference to the internal `Actor`.

   Retrieve a reference to the internal `Actor`.

   returns

     the internal `ActorRef`

   Definition Classes
     PlanetSideServerObject
5.  def Actor_=(control: ActorRef): ActorRef

   Assign an `Actor` to act for this server object.

   Assign an `Actor` to act for this server object. This reference is only set once, that is, as long as the internal `ActorRef` directs to `ActorRef.noSender` (`null`).

   control

     the `Actor` whose functionality will govern this server object

   returns

     the current internal `ActorRef`

   Definition Classes
     PlanetSideServerObject
6.  def CanDamage: Boolean
   Definition Classes
     Vitality
7.  def CanRepair: Boolean
   Definition Classes
     Vitality
8.  def ClearHistory(): List[VitalsActivity]
   Definition Classes
     VitalsHistory
9.  def Continent: String
   Definition Classes
     ZoneAware
10.  def Continent_=(zoneId: String): String

    Give the entity a custom `Zone` identifier.

    Give the entity a custom `Zone` identifier.

    zoneId

      the custom identifier of the `Zone` object

    returns

      the identifier of the `Zone` object

    Definition Classes
      ZoneAware
11.  def DamageModel: DamageAndResistance
    Definition Classes
      Amenity → Vitality
12.  def DefaultHealth: Int
    Definition Classes
      Vitality
13.  def Destroyed: Boolean
    Definition Classes
      PlanetSideGameObject
14.  def Destroyed_=(state: Boolean): Boolean
    Definition Classes
      PlanetSideGameObject
15.  def Entity: WorldEntity
    Definition Classes
      PlanetSideGameObject
16.  def Entity_=(newEntity: WorldEntity): Unit
    Definition Classes
      PlanetSideGameObject
17.  def Faction: types.PlanetSideEmpire.Value
    Definition Classes
      Amenity → FactionAffinity
18.  def Faction_=(fac: types.PlanetSideEmpire.Value): types.PlanetSideEmpire.Value
    Definition Classes
      FactionAffinity
19.  def GUID: PlanetSideGUID
    Definition Classes
      IdentifiableEntity → Identifiable
20.  def GUID_=(guid: PlanetSideGUID): PlanetSideGUID
    Definition Classes
      IdentifiableEntity → Identifiable
21.  def GUID_=(guid: StalePlanetSideGUID): PlanetSideGUID

    Always intercept `StalePlanetSideGUID` references when attempting to mutate the GUID value.

    Always intercept `StalePlanetSideGUID` references when attempting to mutate the GUID value.

    guid

      the valid GUID to assign

    returns

      never returns

    Definition Classes
      IdentifiableEntity
    Exceptions thrown

      ``AssigningGUIDException`` always

22.  def HasGUID: Boolean

    Flag when the object has no GUID (initial condition) or is considered stale.

    Flag when the object has no GUID (initial condition) or is considered stale.

    returns

      whether the value of the GUID is a valid representation for this object

    Definition Classes
      IdentifiableEntity
23.  def Health: Int
    Definition Classes
      Vitality
24.  def Health_=(assignHealth: Int): Int
    Definition Classes
      Vitality
25.  def History(result: DamageResult): List[VitalsActivity]

    Very common example of a `VitalsActivity` event involving damage.

    Very common example of a `VitalsActivity` event involving damage.

    result

      the fully-informed entry

    returns

      the list of previous changes to this object's vital statistics

    Definition Classes
      VitalsHistory
26.  def History(action: Option[VitalsActivity]): List[VitalsActivity]

    A `VitalsActivity` event must be recorded.

    A `VitalsActivity` event must be recorded. Add new entry to the front of the list (for recent activity).

    action

      the fully-informed entry

    returns

      the list of previous changes to this object's vital statistics

    Definition Classes
      VitalsHistory
27.  def History(action: VitalsActivity): List[VitalsActivity]

    A `VitalsActivity` event must be recorded.

    A `VitalsActivity` event must be recorded. Add new entry to the front of the list (for recent activity).

    action

      the fully-informed entry

    returns

      the list of previous changes to this object's vital statistics

    Definition Classes
      VitalsHistory
28.  def History: List[VitalsActivity]
    Definition Classes
      VitalsHistory
29.  def Invalidate(): Unit

    Indicate that the current GUID is no longer a valid representation of the object.

    Indicate that the current GUID is no longer a valid representation of the object. Transforms whatever the current GUID is into a `StalePlanetSideGUID` entity with the same value. Doing this restores the object to its default mutation option ("the ability to set a new valid GUID"). The current GUID will still be accessed as if it were valid, but it will be wrapped in the new stale object.

    Definition Classes
      IdentifiableEntity
30.  def LastDamage: Option[DamageResult]
    Definition Classes
      VitalsHistory
31.  def LastShot: Option[DamageResult]

    Find, specifically, the last instance of a weapon discharge vital statistics change.

    Find, specifically, the last instance of a weapon discharge vital statistics change.

    returns

      information about the discharge

    Definition Classes
      VitalsHistory
32.  def LocationOffset: Vector3
33.  def LocationOffset_=(off: Option[Vector3]): Vector3
34.  def LocationOffset_=(off: Vector3): Vector3
35.  def MaxHealth: Int
    Definition Classes
      Vitality
36.  def MaxHealth_=(default: Option[Int]): Int
    Definition Classes
      Vitality
37.  def MaxHealth_=(default: Int): Int
    Definition Classes
      Vitality
38.  def Orientation: Vector3
    Definition Classes
      PlanetSideGameObject → WorldEntity
39.  def Orientation_=(vec: Vector3): Vector3
    Definition Classes
      PlanetSideGameObject → WorldEntity
40.  def Owner: AmenityOwner

    Reference the object that is in direct association with (is superior to) this one.

    Reference the object that is in direct association with (is superior to) this one.

    returns

      the object associated as this object's "owner"

41.  def Owner_=(obj: AmenityOwner): AmenityOwner

    Set an object to have a direct association with (be superior to) this one.

    Set an object to have a direct association with (be superior to) this one.

    obj

      the object trying to become associated as this object's "owner"

    returns

      the object associated as this object's "owner"

    See also

      `Amenity.AmenityTarget`

42.  def Position: Vector3
    Definition Classes
      PlanetSideGameObject → WorldEntity
43.  def Position_=(vec: Vector3): Vector3
    Definition Classes
      PlanetSideGameObject → WorldEntity
44.  def RadiationShielding: Float
    Definition Classes
      StandardResistanceProfile → ResistanceProfile
45.  def ResetControl(): ActorRef
    Definition Classes
      PlanetSideServerObject
46.  def Resist(dtype: vital.base.DamageType.Value): Float
    Definition Classes
      ResistanceProfile
47.  def ResistanceAggravated: Int
    Definition Classes
      StandardResistanceProfile → ResistanceProfile
48.  def ResistanceDirectHit: Int
    Definition Classes
      StandardResistanceProfile → ResistanceProfile
49.  def ResistanceSplash: Int
    Definition Classes
      StandardResistanceProfile → ResistanceProfile
50.  def Subtract: DamageProfile
    Definition Classes
      StandardResistanceProfile → ResistanceProfile
51.  def Velocity: Option[Vector3]
    Definition Classes
      PlanetSideGameObject → WorldEntity
52.  def Velocity_=(vec: Option[Vector3]): Option[Vector3]
    Definition Classes
      PlanetSideGameObject → WorldEntity
53.  def Velocity_=(vec: Vector3): Option[Vector3]
    Definition Classes
      WorldEntity
54.  def Zone: Zone
    Definition Classes
      Amenity → ZoneAware
55.  def Zone_=(zone: Zone): Zone

    When assigning a new `Zone` object for the `Vehicle` object, eliminate

    When assigning a new `Zone` object for the `Vehicle` object, eliminate

    zone

      a reference to the `Zone` object

    returns

      a reference to the `Zone` object

    Definition Classes
      ZoneAware
56.  final def asInstanceOf[T0]: T0
    Definition Classes
      Any
57.  def clone(): AnyRef
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
58.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
59.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
60.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
61.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
62.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
63.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
64.  def isMoving(test: Float): Boolean

    This object is not considered moving unless it is moving at least as fast as a certain velocity.

    This object is not considered moving unless it is moving at least as fast as a certain velocity.

    test

      the (squared) velocity to test against

    returns

      `true`, if we are moving; `false`, otherwise

    Definition Classes
      WorldEntity
65.  def isMoving(test: Vector3): Boolean

    This object is not considered moving unless it is moving at least as fast as a certain velocity.

    This object is not considered moving unless it is moving at least as fast as a certain velocity.

    test

      the velocity to test against

    returns

      `true`, if we are moving; `false`, otherwise

    Definition Classes
      WorldEntity
66.  def isMoving: Boolean

    A velocity of non-zero is the same as moving.

    A velocity of non-zero is the same as moving.

    returns

      `true`, if we are moving; `false`, otherwise

    Definition Classes
      WorldEntity
67.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
68.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
69.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
70.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
71.  def toString(): String
    Definition Classes
      AnyRef → Any
72.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
73.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
74.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Inherited from StandardResistanceProfile

### Inherited from ResistanceProfile

### Inherited from Vitality

### Inherited from VitalsHistory

### Inherited from PlanetSideServerObject

### Inherited from ZoneAware

### Inherited from FactionAffinity

### Inherited from PlanetSideGameObject

### Inherited from WorldEntity

### Inherited from IdentifiableEntity

### Inherited from Identifiable

### Inherited from AnyRef

### Inherited from Any

### Ungrouped